*: BOX() was written by Dougie Brown @Compuserve 100762,1050.
*: It not only draws shadowed boxes, but "dims" the text under the
*: shadows.
*: Placed in the public domain December 1995 on condition that
*: this ownership notice is retained in this or subsequently-
*: altered versions, including integrations into users' own
*: programs.  All comments to me are welcome.
***************************************************************
*: Parameters are: 1) Top row  2) left column  3) bottom row  4) right column
*:                 5) specific color for border (Text string, otherwise passing
*:                    NULL passes the current color  6) Shadow T/F
*:                 7) Border: 0=No border, 1=Single line, 2=Double lines
*:
*: Examples: Box(8,10,16,70,"",.T.,1)
*:         : Box(12,20,18,60,"w+/bg",.T.,0)
*:         : Box(4,30,6,50,"w+/bg",.F.,0)
***************************************************************
setcolor("w+/b")                   && example purposes only
@ 0,0 say repl("x",2000)           && example purposes only
Box(12,30,14,50,"w+/bg",.T.,0)     && example purposes only

 Function box
     Parameters top,left,bottom,right,color,shadow,border
     _oldcolor = setcolor()
     if color > " "
          setcolor(color)
     endif
     stor "" to bottshad, rightshad
     oldbottom = savescreen(bottom+1,left+2,bottom+1,right+2)
     oldright = savescreen(top+1,right+1,bottom,right+2)
     bottomlen = len(oldbottom)
     rightlen = len(oldright)
     if "U" $ type("border")                 && If no Border paramater passed
          border = 2                         && Defaults to Double lines
     endif

     if shadow
     *: INT() no. of foreground colors is as follows:-
     *: 0 = Black  1 = Blue  2 = Green  3 = Cyan  4 = Red  5 = Violet  6 = Brown
     *: 7 = White
          for z = 1 to bottomlen step 2
               bottshad = bottshad+subs(oldbottom,z,1) + chr(7)
          next z

          for z = 1 to rightlen step 2
               rightshad = rightshad+subs(oldright,z,1) + chr(7)
          next z
     endif

     @ top,left clear to bottom,right
     if border = 1
          @ top,left to bottom,right
     elseif border = 2
          @ top,left to bottom,right doub
     endif

     if shadow
          if bottom < 24
               restscreen(bottom+1,left+2,bottom+1,right+2,bottshad)
          endif
          if right < 78
               restscreen(top+1,right+1,bottom,right+2,rightshad)
          endif
     endif

     setcolor(_oldcolor)

retu ""
